
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <title>Projecte web compartit </title>
    <link rel="stylesheet" href="style.css">
  </head>
  <body>
    <div class="container">
      <h1>GIT</h1>
      <div class="intro">
        <h2>Introducció</h2>
		<section>
        		<p>Git es un software lliure que permet realitzar operacions de forma local, fent que aquestes actuin amb gran rapidesa. Esta programat en C i Perl.</p>
			<p>Qualsevol directori pot ser un repositori Git i si es vol inicialitzar un directori com a tal s'utilitzara la comanda <strong>git init</strong>, aixó crearà un directori ocult sota el nom .git que tindrà tota la informació.</p>
			<p>Al fer això l'estructura amb la que treballarem estarà composta per el nostre directori de treball, una àrea d'staging i un repositori local. Com treballem al directori cada cop que afegim un arxiu aquest estarà aquí.</p>
			<p>Si volem comunicar el canvi realitzat al directori a l'area d'staging escriurem la comanda <strong>git add (nom del fitxer),</strong> al fer-ho el canvi realitzat es trobarà aquí també.</p>
		</section>
			<p>Si fem servir la comanda <strong>git commit</strong>comunicarem els canvis al repositori local, aquesta comanda requereix d'un comentari per saber sobre els canvis realitzats a la versió, en casos normals s'obrirà el editor i ens deixarà ficar un missatge, pero afegint <strong>-m "missatge del commit"</strong> a l'anterior comanda podrem afegir missatges de forma directa.</p>
	<h3>Comandes</h3>
		<ul>
			<li><strong>git log</strong> ens permetrà veure l'historial de commits realitzats al repositori.</li>
			<li><strong>git status</strong> serveix per a poder saber l'estat d'un repositori.</li>
			<li><strong>git diff "nom fitxer"</strong> ens permetrà veure exactament quins canvis han estat realitzats al fitxer respecte al repositori.</li>
			<li><strong>git restore "nom arxiu"</strong> ens permetrà recuperar la versió del repositori de l'arxiu en cas de que no l'haguem portat a l'àrea d'stage</li>
			<li><strong>git restore --source idCommit</strong>es una comanda molt important, es pot recuperar una versió antiga del repositori (commit) fent-la servir</li>
		</ul>
      </div>
      <div class="branches">
        <h2>Branques</h2>
        <p>Les branques, son diferents lineas de treball on tu treballes sobre una versio del projecte, que no afecta al projecte original.
        	<br>Si nosaltres ens trobem en una rama diferent a la original, podem fer totes les proves que volguem sense afectar al projecte original, es una forma de fer testeijos i si el projecte acaba danyat, no existeix cap problema degut a que no es l'original. També podem guardar diferents versions de les rames quan executen un commit
  		<br>La branca que sempre ens trobem es la branca master, que es la branca que es crea quan fem <strong>git init</strong>
		<br>Quan nosaltres fem un commit, a part de crear una nova versio del projecte, el que fem es moure el <strong>HEAD</strong> al nou commit. El HEAD es conegut com l'apuntador, degut a que senyala a la versió en la que treballem.</p>
	<section>
		<h3>Comandes</h3>
		<ul>
			<li>La primera ordre que veurem es l'ordre per crear una nova branca: <strong>git branch <i>nom_branca</i></strong></li>
			<li>La segona ordre que trobem es: <strong>git checkout <i>nom_branca</i></strong>. Aquesta ordre ens permitira cambiar el puntador HEAD cap la nova branca i així poder treballar en aquesta nova branca</li>
			<li>Si nosaltres executem l'ordre <strong>git checkout master</strong> sera moure l'apuntador HEAD cap la branca master. Quan fem aixó, els fitxers que nosaltres veurem seran els mateixos que teníem abans de canviar de branca </li>
			<li>La tercera ordre que anems a mostrar es: <strong>git branch --delete <i>nom_branca</i></strong>. Aquesta ordre eliminara la branca que hem escrit.</li>
			<li>La següent ordre es: <strong>git merge <i>nom_branca</i></strong>. Aquesta ordre fusionara la branca en la que ens trobem amb la que escrivim en l'ordre</li>
			<li>Si en una branca hem realitzat unes modificacions i en l'altre branca fem unes altres. A l'hora de fer el merge ens dira que la fusió automatica ha fallat i ens si obrim el fitxer veurem unes lineas que no hem escrit</li>
		</ul>
	</section>
      </div>
      <div class="remot">
        <h2>Remot</h2>
        <p>El repositori en remot el que fa es crear una copia fora del nostre ordinador (en el núvol).</p>
	<p>Els Repositoris remots més comuns són:</p>
	<ul>
		<li>Github</li>
		<li>BitBucket</li>
		<li>Gitlab</li>
	</ul>
	<p>Per crear un repositori remot, amb un repositori git creat anteriorment hem d'utilitzar la comanda <strong>git remote add origin [url_git]</strong> on url_git es la url del repositori git creat.</p>
	<p>També cal lincar la branca del local amb la del repositori amb la comanda <strong>git branch --set-upstream master origin/master</strong> que pot ser master o com es digui en el teu local</p>
	<p>També podem fer-ho a l'inrevès, tenim el repositori remot i el volem en local, ho farem amb la comanda <strong>git clone url_git</strong> on url_git es la url del repositori remot</p>
	<h3>Divergencies entre remot i local</h3>
	<p>Si fas treball en el teu repositori local i al mateix temps, un company puja la seva feina al remot, els registres avancen de forma diferent</p>
	<p> Per pujar el nostre treball utilizarem la comanda <strong>git push -u origin master</strong> i si volem descarregar els commit fets al remot que no tenim en local utilitzarem <strong> git pull </strong></p>
	<h3>Altres comandes</h3>
	<p><strong>git remote</strong> Veure els noms del repositoris remots que tenim en el nostre ordinador</p>
	<p><strong>git remote -v</strong> Veure els noms dels repositoris remots i la seva URL</p>
	<p><strong>git fetch origin</strong> Veure l'informacio del repositori remot</p> 
      </div>
   </div>
  </body>
</html>
